unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, DB, SqlExpr, Grids, DBGrids,
  dbexpca400, StdCtrls, Provider, DBClient, ExtCtrls, DBCtrls, ComCtrls,
  Buttons;

type
  TForm1 = class(TForm)
    MasterGrid: TDBGrid;
    SQLConnection1: TSQLConnection;
    MasterCDS: TClientDataSet;
    dsMasterCDS: TDataSource;
    DSP: TDataSetProvider;
    ExecQuery: TSQLQuery;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    OpenBtn: TSpeedButton;
    CreateMasterBtn: TSpeedButton;
    DBNavigator1: TDBNavigator;
    ApplyBtn: TSpeedButton;
    Panel1: TPanel;
    CreateMasterMemo: TMemo;
    CreateDetailMemo: TMemo;
    Splitter1: TSplitter;
    CreateDetailBtn: TSpeedButton;
    InsertSampleBtn: TSpeedButton;
    DetailGrid: TDBGrid;
    Splitter2: TSplitter;
    DetailCDS: TClientDataSet;
    dsDetailCDS: TDataSource;
    dsMaster: TDataSource;
    Detail: TSQLQuery;
    Master: TSQLQuery;
    MasterCDSCUSTOMERNO: TStringField;
    MasterCDSCUSTOMER: TStringField;
    MasterCDSDetail: TDataSetField;
    procedure OpenBtnClick(Sender: TObject);
    procedure CreateMasterBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
    procedure CreateDetailBtnClick(Sender: TObject);
    procedure InsertSampleBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.OpenBtnClick(Sender: TObject);
begin
  MasterCDS.Active:= False;
  MasterCDS.Active:= True;
end;

procedure TForm1.CreateMasterBtnClick(Sender: TObject);
begin
  Screen.Cursor:= crHourGlass;
  Try
    ExecQuery.SQL.Text:= CreateMasterMemo.Text;
    If ExecQuery.ExecSQL>=0 Then
      MessageDlg('Table created', mtInformation, [mbOk], 0)
    Else
      MessageDlg('Creation failed', mtInformation, [mbOk], 0);
  Finally
    Screen.Cursor:= crDefault
  End
end;

procedure TForm1.CreateDetailBtnClick(Sender: TObject);
begin
  Screen.Cursor:= crHourGlass;
  Try
    ExecQuery.SQL.Text:= CreateDetailMemo.Text;
    If ExecQuery.ExecSQL>=0 Then
      MessageDlg('Table created', mtInformation, [mbOk], 0)
    Else
      MessageDlg('Creation failed', mtInformation, [mbOk], 0);
  Finally
    Screen.Cursor:= crDefault
  End
end;

procedure TForm1.ApplyBtnClick(Sender: TObject);
begin
  MasterCDS.ApplyUpdates(0)
end;

procedure TForm1.InsertSampleBtnClick(Sender: TObject);
Var
  Count: Integer;

  Procedure Exec (Value: String);
  Begin
    Screen.Cursor:= crHourGlass;
    Try
      ExecQuery.SQL.Text:= Value;
      If ExecQuery.ExecSQL<0 Then
        MessageDlg('Exec failed: '+Value, mtInformation, [mbOk], 0)
      Else
        Inc(Count)
    Finally
      Screen.Cursor:= crDefault
    End
  End;

begin
  Count:= 0;
  Exec('insert into master (customerno, customer) values (''41'', ''Shomway, Gordon Alf'')');
  Exec('insert into master (customerno, customer) values (''42'', ''Sawatzki, Peter'')');
  Exec('insert into detail (customerno, orderno, item) values (''42'', ''31001'', ''Ice Cream'')');
  Exec('insert into detail (customerno, orderno, item) values (''41'', ''31002'', ''Pizza XXL'')');
  Exec('insert into detail (customerno, orderno, item) values (''41'', ''31003'', ''Cat, red'')');
  Exec('insert into detail (customerno, orderno, item) values (''41'', ''31004'', ''Cat, white'')');
  MessageDlg(Format('%d rows inserted.', [Count]), mtInformation, [mbOk], 0);
end;

end.
