using System;
using System.Data;
using Borland.Data.Provider;

namespace ConsoleSimple
{
        /// <summary>
        /// Simple CONSOLE application that demonstrates the PS.Data.iSeries provider
        /// it prints the contents of the QIWS.QCUSTCDT table
        /// </summary>
        class ConsoleTestiSeries
        {
                [STAThread]
                static void Main(string[] args)
				{       string SQL = "select * from QIWS.QCUSTCDT"; // this is a table on every iSeries
						string Conn = "Database=*;Username=;Password= ;Assembly=PS.Data.iSeries, Version=1.0.0.0, Culture=neutral, PublicKeyToken=df047b757d3f379a";
						Console.Write("Connection to iSeries database system...");
						BdpConnection bdpConn = new BdpConnection(Conn);
						bdpConn.Open();
                        Console.WriteLine("Done.");
                        BdpCommand bdpCmd = new BdpCommand(SQL, bdpConn);
                        BdpDataReader bdpReader = bdpCmd.ExecuteReader();
                        Console.WriteLine("CustNo: Name (Street)");
                        while (bdpReader.Read())
                                Console.WriteLine(bdpReader["CUSNUM"] + ": " + bdpReader["LSTNAM"] + " (" + bdpReader["STREET"]+")");
                        bdpReader.Close();
                }
        }
}
