unit Test400Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, DBCtrls, Provider, DBClient, DB, SqlExpr,
  Buttons, StdCtrls, Grids, DBGrids, ExtCtrls,
  System.ComponentModel;

type
  TTest400Form = class(TForm)
    AS400Connection: TSQLConnection;
    CmdPanel: TPanel;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    edAS400: TEdit;
    Label2: TLabel;
    edUser: TEdit;
    Label3: TLabel;
    edPassword: TEdit;
    mnQuery: TMemo;
    Label4: TLabel;
    OpenBtn: TSpeedButton;
    DataSource1: TDataSource;
    SQLQuery1: TSQLQuery;
    ClientDataSet1: TClientDataSet;
    DataSetProvider1: TDataSetProvider;
    DBNavigator1: TDBNavigator;
    ApplyButton: TSpeedButton;
    Log: TMemo;
    Splitter1: TSplitter;
    Mon: TCheckBox;
    Edit1: TEdit;
    Label5: TLabel;
    SpeedTestBtn: TSpeedButton;
    procedure OpenBtnClick(Sender: TObject);
    procedure ApplyButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FSQLMonitor: TSQLMonitor;
    //procedure Trace(Sender: TObject; CBInfo: pSQLTRACEDesc; var LogTrace: Boolean);
  public
    { Public declarations }
  end;

var
  Test400Form: TTest400Form;

implementation

{$R *.dfm}

procedure TTest400Form.OpenBtnClick(Sender: TObject);
begin
  If Trim(edAS400.Text)='' Then edAS400.Text:= '*';
  AS400Connection.Connected:= false;
  AS400Connection.Params.Values['DATABASE']:= Trim(edAS400.Text);
  AS400Connection.Params.Values['USER_NAME']:= Trim(edUser.Text);
  AS400Connection.Params.Values['PASSWORD']:= Trim(edPassword.Text);

  FSQLMonitor.Active:= Mon.Checked;
  ClientDataSet1.Active:= False;
  SQLQuery1.SQL.Assign(mnQuery.Lines);
  If SQLQuery1.Params.Count=1 Then
    SQLQuery1.Params[0].AsString := edit1.Text;
  ClientDataSet1.Active:= True;
end;

procedure TTest400Form.ApplyButtonClick(Sender: TObject);
begin
  ClientDataSet1.ApplyUpdates(0)
end;

{procedure TTest400Form.Trace(Sender: TObject; CBInfo: pSQLTRACEDesc; var LogTrace: Boolean);
begin
  LogTrace:= False;
  Log.Lines.Add(CBInfo.pszTrace);
end;}

procedure TTest400Form.FormCreate(Sender: TObject);
begin
  FSQLMonitor:= TSQLMonitor.Create(Self);
  FSQLMonitor.SQLConnection:= AS400Connection;
  //FSQLMonitor.OnTrace:= Trace;
end;

end.
